# Run as:  perl postprocessing.pl <inputfile >outputfile

#! /usr/local/bin/perl -w
use POSIX qw(ceil floor);
use strict;

my %motifhash=();
my $num=0;
my ($motifhash_ref, $motifseq_ref)=read_em();
my %motifhash=%$motifhash_ref;
my %motifseqhash=%$motifseq_ref;

#sort the motifhash by the position of the first instance. 
my @sortedMotifs=sort mysort keys %motifhash;

 
my %InstanceHash=();
foreach my $motif (@sortedMotifs)
{
     my $flag=0;
     my $len=length($motif);
     my $motif_all=$motifhash{$motif};
     my ($first,$second)=split(/ X /,$motif_all);
     my @instances=split(/ o /,$first);
     my $ins0=$instances[0];
     my $seqs_order=get_seqs($motif_all);
     my ($seq0,$pos0,$str0)=split(/,/,$ins0);
     my $pos_pre=$pos0+1;
     if(exists $InstanceHash{$seqs_order}{$pos_pre})
     {
        my $old=$InstanceHash{$seqs_order}{$pos_pre};
        #print "Exist back-consecutive $old for motif $seq0,$pos0,$motif \n";
        my $new_motif=substr($motif,0,1).$old;
        if(!exists $motifhash{$old}) { 
           print "Error when no motifhash existed for $old \n";
          # delete $InstanceHash{$seqs_order}{$pos_pre};
        }
        my $old_all=$motifhash{$old};
        my ($first,$second2)=split(/ X /,$old_all);
        my @oldinstances=split(/ o /,$first);
        my @newinstances=join_two(\@oldinstances,\@instances);
        #print "Exist back-consecutive $old:$old_all for motif $seq0,$pos0,$motif \n";
        #print "For the old $pos_old,$old and new is $new_motif \n";
        $first=join(' o ',@newinstances);       
        if($#newinstances==$#oldinstances){
          delete $InstanceHash{$seqs_order}{$pos_pre};
          delete $motifhash{$old};
          delete $motifhash{$motif};
          if($second2<$second) { $second=$second2;}
          #my $new_second=($second+$second2); 
          $motifhash{$new_motif}=$first." X ".$second;
          $InstanceHash{$seqs_order}{$pos0}=$new_motif;
          $flag=1;
          
       }
       else {  #print "failure in joining these two inst arrays:$first \n ";
          $flag=2; 
       }
   }
   if(exists $InstanceHash{$seqs_order}{$pos0}&&$flag!=1){
      $flag=3;
      my $old=$InstanceHash{$seqs_order}{$pos0};
      if($old ne $motif){
      my $old_all=$motifhash{$old};
      my ($first,$second2)=split(/ X /,$old_all);
      my @oldinstances=split(/ o /,$first);
      if(check_two(\@oldinstances,\@instances)==1){
           if($second < $second2) { $motifhash{$old}=$first." X ".$second; } 
           delete $motifhash{$motif};
      }
      else { # failure in check the two inst arrays,keep the one with smaller evalue
          
         if($second < $second2){
              delete $motifhash{$old};
              $InstanceHash{$seqs_order}{$pos0}=$motif;
         }
         else { delete  $motifhash{$motif};}
         }
     }
    }
   if($flag!=1 && $flag !=3) {
      $InstanceHash{$seqs_order}{$pos0}=$motif;    
      $flag=0; 
   }  
}



foreach my $motif (keys %motifhash)
{
     my $len=length($motif);
     my $motif_all=$motifhash{$motif};
     my ($first,$second)=split(/ X /,$motif_all);
     my @instances=split(/ o /,$first);
     my $numd=floor($len/20);
     if($numd>1&&$numd<4) { 
       #print "Split $motif with length $len and evalue $second into $numd parts \n";
       my $lend=$len/$numd;
       for( my $i=0;$i<$numd;$i++){
         my $motifd=substr($motif,$i*$lend,$lend);
         my @newinsts=();
         foreach my $insp (@instances){
          my ($seq_old,$pos_old,$str_old)=split(/,/,$insp);
          my $pos2=$pos_old+int($i*$lend);
          my $str2=substr($str_old,int($i*$lend),$lend);
          my $newins2="$seq_old,$pos2,$str2";
          push(@newinsts,$newins2);
        }
        $first=join(' o ',@newinsts);
        $motifhash{$motifd}=$first." X ".$second;
        @newinsts=();
     }
     delete $motifhash{$motif};
   }
}

print keys( %motifhash ) . "\n";




#sort the motifhash by the evalue. 
@sortedMotifs=sort mysort2 keys %motifhash;

$num=0;
foreach my $motif (@sortedMotifs)
{
    my $new=$motifhash{$motif};
    my ($first,$second)=split(/ X /,$new);
    my @instances=split(/ o /,$first);
    $motif=~tr/[A-Z]/[a-z]/;
    my ($seq0,$pos0,$str0)=split(/,/,$instances[0]);
    my @corrected=split(//,lc($str0));
    #print  "\n $motif $second \n";
    my @sortedInsts=sort {
          my ($seqa,$posa,$stra)=split(/,/,$a);
          my ($seqb,$pos,$str)=split(/,/,$b);
          $motifseqhash{$motif}{$seqa} <=> $motifseqhash{$motif}{$seqb} } @instances; 
    foreach my $instance (@sortedInsts){
       my ($seq,$pos,$str)=split(/,/,$instance);
       for(my $i=0;$i<$#corrected+1;$i++){
          if( lc(substr($str,$i,1)) ne lc(substr($str0,$i,1))){
               $corrected[$i]="n";
          }
       }
       print "$str $seq\/$pos \n";
    }
   my $correctedm=join("",@corrected); 
   $correctedm=~tr/[n]/[\-]/;
   print "$correctedm $second $num \n";
   $num++;
}


sub read_em {
  my %instances=();
  my $num=0;
  my $flag=0;
  my %motifhash=();
  my %motifseqhash=();
  my %seqhash=();
  my $seqnum=0;
  while(my $line=<STDIN>){
    #print " The Line is $line \n";
     if($line=~/(^[ACGTNacgtn]+)(\s+)(\w+)(\/)(\d+)/){
         #print " The instance line0: $line \n";
         my $instance=$1;                                                                                                                          my $seq=$3;                                                                                                                               my $pos=$5;  
         my $report="$seq,$pos,$instance";
         if(InsFilter($instance)==1) { $flag=1;}                                                                                          
         else { $instances{$report}=$pos ; }                                                                         
         $seqhash{$seq}=$seqnum;
         $seqnum++;
      }
     elsif($line=~/(^[ACGTNacgtn]+)(\s+)(\S+)(\s+.*)(\/)(\d+)/){
         #print " The instance line1: $line \n"; 
         my $instance=$1;
         my $seq=$3;
         my $pos=$6;
         my $report="$seq,$pos,$instance"; 
         if(InsFilter($instance)==1) { $flag=1;}
         else { $instances{$report}=$pos ; }
         $seqhash{$seq}=$seqnum; 
         $seqnum++;
      }
     elsif($line=~/([ACGTacgt-]+)(\s+\d+\s+)(\d+\.\d+)(e\-\d+)(.*)/){
       #print " The motif line: $line \n";
       my $motif=$1;
       my $score1=$3;
       my $score2=$4;
       if($flag!=1) {       
              my @sortedInstances=sort { $instances{$b} <=> $instances{$a} || $a cmp $b } keys %instances;
              my $motifInstances=join(' o ',@sortedInstances);
              my $motifInstances2=$motifInstances." X ".$score1.$score2;
              $motifhash{$motif}=$motifInstances2;
              foreach my $inst (@sortedInstances)
              {
                 my ($seq,$pos,$str)=split(/,/,$inst);
                 $motifseqhash{$motif}{$seq}=$seqhash{$seq};
              }
              %seqhash=();
              $seqnum=0;
              %instances=();
              $num=$num+1;
              
      }
      %instances=();
      %seqhash=();
      $seqnum=0;
      $flag=0; 
   }     
  else { ; }
  }
 return (\%motifhash, \%motifseqhash);
}


sub InsFilter {
   my $ins=lc($_[0]);
   my @a1= $ins=~/.*(..)\1{5,}.*/;
   if($#a1>=0){ return 1;}
   @a1=$ins=~/.*(...)\1{4,}.*/;
   if($#a1>=0) {return 1;}
   return 0;
}


#sort the motifhash by the position of the first instance. 
sub mysort {
                 my $new=$motifhash{$a};
                 my ($first,$second)=split(/ X /,$new);
                 my @instances1=split(/ o /,$first);
                 my ($seq1,$pos1,$ins1)=split(/,/,$instances1[0]);

                 $new=$motifhash{$b};
                 ($first,$second)=split(/ X /,$new);
                 my @instances2=split(/ o /,$first);
                 my ($seq2,$pos2,$ins2)=split(/,/,$instances2[0]);

                 $pos2 <=> $pos1||length($b)<=>length($a)||$b cmp $a;
                 }


#sort the motifhash by the evalue
    sub mysort2 {
                 my $new=$motifhash{$a};
                 my ($first,$second)=split(/ X /,$new);
                 $new=$motifhash{$b};
                 my ($firstb,$secondb)=split(/ X /,$new);
                 $second <=> $secondb||length($a) <=>length($b)||$a cmp $b;
                 }


#subroutine to join two consecutive instance arrays
sub join_two {
 my @inst1=@{$_[0]};
 my @inst2=@{$_[1]};
 if($#inst1==$#inst2){
    my $num=0;
    my @newinsts=();
    for(my $i=0;$i<$#inst1+1;$i++){
       my $ins_old=$inst1[$i];
       my ($seq_old,$pos_old,$str_old)=split(/,/,$ins_old);
       my ($seq2,$pos2,$str2)=split(/,/,$inst2[$i]);
       if($seq_old eq $seq2&&$pos_old==$pos2+1){
         $pos_old=$pos2;
         $str_old=substr($str2,0,1).$str_old;
         my $newins="$seq_old,$pos_old,$str_old";
         #print " the join instance $newinstance at $pos\n";
         push(@newinsts,$newins);
         $num++;
       }
    }
    return (@newinsts);
 }
 else {
  print "Error in join_two subroutine: $#inst1 and $#inst2 !\n";
 }
 return ();
}

#subroutine to check two instance arrays to see if they start at the same positions
sub check_two {
 my @inst1=@{$_[0]};
 my @inst2=@{$_[1]};
 if($#inst1==$#inst2){
    my $num=0;
    for(my $i=0;$i<$#inst1+1;$i++){
       my $ins_old=$inst1[$i];
       my ($seq_old,$pos_old,$str_old)=split(/,/,$ins_old);
       my ($seq2,$pos2,$str2)=split(/,/,$inst2[$i]);
       if($seq_old eq $seq2&&$pos_old==$pos2){
         $num++;
       }
    }
    if($num==$#inst1+1) {return 1;};
 }
 else {
  print "Error in check_two subroutine: $#inst1 and $#inst2 !\n";
 }
 return 0;
}


sub get_seqs {
  my $motif_all=$_[0];
  (my $first,my $second)=split(/ X /,$motif_all);
  my @instances=split(/ o /,$first);
  my $seqs="";
  foreach my $inst (@instances){
   my ($seq0,$pos0,$str0)=split(/,/,$inst);
   $seqs.=$seq0;
  }
  return $seqs;
}


